﻿
Imports System.IO.Ports


Public Class UART_remote


    Dim app_state As String = "Conect"




    Private Sub Button17_Click(sender As Object, e As EventArgs) Handles Button17.Click

        Button17.Text = "Connecting"
        app_state = "Connecting"

        Try
            If (SerialPort1.IsOpen) Then SerialPort1.Close()
            SerialPort1.PortName = ComboBox1.Text
            SerialPort1.BaudRate = 115200
            SerialPort1.Handshake = Handshake.None
            SerialPort1.DtrEnable = False
            SerialPort1.Open()
            Threading.Thread.Sleep(100)

            SendCommand(&HFA, &HFA) ''send dummy command - test if device is connected OK | Expected 1B response "0" 
            Timer1.Enabled = True

        Catch ex As Exception
            Timer1.Enabled = False
            Debug.Print("Comport cant be opened - " & ComboBox1.Text)
            app_state = "Error"
            Exit Sub
        End Try

    End Sub

    Private Sub UART_remote_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        ''Load all available ports
        ComboBox1.Items.AddRange(IO.Ports.SerialPort.GetPortNames())

    End Sub

    Private Sub SendCommand(cmd As Byte, param As Byte)

        Dim buf(5) As Byte

        If SerialPort1.IsOpen Then

            Try
                buf(0) = &HCD
                buf(1) = &HA5
                buf(2) = cmd
                buf(3) = param
                buf(4) = cmd Xor param
                SerialPort1.Write(buf, 0, 5)

            Catch ex As Exception
                Debug.Print("error writing port " & ex.Message)

            End Try

        End If


    End Sub


    Private Sub SerialPort1_DataReceived(sender As System.Object, e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived

        Dim resp(1024) As Byte
        resp(0) = 100

        Dim len As Integer = SerialPort1.BytesToRead
        SerialPort1.Read(resp, 0, len)

        Select Case resp(0)

            Case 0
                If app_state = "Connecting" Then
                    app_state = "Connected"
                End If

            Case 255


            Case Else

        End Select

    End Sub



    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        If app_state = "Connecting" Then
            app_state = "Error"
        End If
        Timer1.Enabled = False
    End Sub

    Private Sub Timer2_Tick(sender As Object, e As EventArgs) Handles Timer2.Tick
        ''app state timer
        Button17.Text = app_state
    End Sub




    ''--------------------------------------------------
    ''Button handlers

    Private Sub Button10_Click(sender As Object, e As EventArgs) Handles Button10.Click
        Call SendCommand(&HC1, 50)
    End Sub

    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click
        Call SendCommand(&HC2, 50)
    End Sub

    Private Sub Button11_Click(sender As Object, e As EventArgs) Handles Button11.Click
        Call SendCommand(&HC3, 50)
    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        Call SendCommand(&HA0, 0)
    End Sub

    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click
        Call SendCommand(&HA6, 0)
    End Sub

    Private Sub Button12_Click(sender As Object, e As EventArgs) Handles Button12.Click
        Call SendCommand(&HAF, 50)
    End Sub

    Private Sub Button24_Click(sender As Object, e As EventArgs) Handles Button24.Click
        Call SendCommand(&H11, 0)
    End Sub

    Private Sub Button23_Click(sender As Object, e As EventArgs) Handles Button23.Click
        Call SendCommand(&H10, 0)
    End Sub

    Private Sub Button22_Click(sender As Object, e As EventArgs) Handles Button22.Click
        Call SendCommand(&H21, 0)
    End Sub

    Private Sub Button21_Click(sender As Object, e As EventArgs) Handles Button21.Click
        Call SendCommand(&H20, 0)
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Call SendCommand(&HAB, 0)
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        Call SendCommand(&HA8, 0)
    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        Call SendCommand(&HA7, 0)
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        Call SendCommand(&HAA, 0)
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Call SendCommand(&HA9, 0)
    End Sub

    Private Sub Button13_Click(sender As Object, e As EventArgs) Handles Button13.Click
        Call SendCommand(&HA4, 0)
    End Sub

    Private Sub Button16_Click(sender As Object, e As EventArgs) Handles Button16.Click
        Call SendCommand(&HA3, 0)
    End Sub

    Private Sub Button15_Click(sender As Object, e As EventArgs) Handles Button15.Click
        Call SendCommand(&HF1, 50)
    End Sub

    Private Sub Button14_Click(sender As Object, e As EventArgs) Handles Button14.Click
        Call SendCommand(&HF2, 50)
    End Sub

    Private Sub Button18_Click(sender As Object, e As EventArgs) Handles Button18.Click
        Call SendCommand(&HA5, 0)
    End Sub
End Class





